/* Copyright (C) 1998 by Holger Veit (Holger.Veit@gmd.de)
 * Use at your own risk! No Warranty! The author is not responsible for
 * any damage or loss of data caused by proper or improper use of this
 * device driver.
 */

#ifndef _NOP_DEVHLP_H_
#define _NOP_DEVHLP_H_

void*  _System DH_Init32(void);
APIRET _System DH_RamSemRequest(int semindex,long timeout);
APIRET _System DH_RamSemClear(int semindex);

#define VMDHA_16M               0x0001
#define VMDHA_FIXED             0x0002
#define VMDHA_SWAP              0x0004
#define VMDHA_CONTIG            0x0008
#define VMDHA_PHYS              0x0010
#define VMDHA_PROCESS           0x0020
#define VMDHA_SGSCONT           0x0040
#define VMDHA_RESERVE           0x0100
#define VMDHA_USEHIGHMEM        0x0800
APIRET _System DH_VMAlloc(ULONG len,ULONG paddr,ULONG flgs,void** laddr);
APIRET _System DH_VMFree(void* laddr);

#define VMDHL_NOBLOCK           0x0001
#define VMDHL_CONTIGUOUS        0x0002
#define VMDHL_16M               0x0004
#define VMDHL_WRITE             0x0008
#define VMDHL_LONG              0x0010
#define VMDHL_VERIFY            0x0020
APIRET _System DH_VMLock(ULONG flgs,void* laddr,ULONG len,
		    void* pages,void* lockh,ULONG* lcnt);
APIRET _System DH_VMunlock(void* lockh);
APIRET _System DH_Verifyaccess(PTR16 addr,USHORT size,int flgs);
APIRET _System DH_VirtToLin(PTR16 addr,void** linaddr);
void*  _System DH_StackToLin(void* stackoff);
struct giseg* _System DH_GetGInfoSeg(void);
struct liseg* _System DH_GetLInfoSeg(void);
APIRET _System DH_Security(ULONG func, void* ptr);
APIRET _System DH_SaveMessage(int msgnum);
APIRET _System DH_AttachSes(void*);
#endif
