; Copyright (C) 1997,1998 by Holger Veit (Holger.Veit@gmd.de)
; Use at your own risk! No Warranty! The author is not responsible for
; any damage or loss of data caused by proper or improper use of this
; device driver.
;
        .386p
	page	66,80

        INCL_DOSERRORS equ 1
        include bseerr.inc
        include devhlp.inc
        include devcmd.inc
        include devsym.inc

        include nop_segdef.inc
	include nop_macro.inc

DATA32 segment
        public  codeend
        public  dataend

        codeend dw offset CODE16:code16_end
        dataend dw offset DATA16:data16_end

DATA32 ends

DATA16 segment
                extrn data16_end : byte
		public device_header

device_header   dd -1
                dw 1100100110000000b
                dw offset CODE16:nop_stub_strategy
                dw offset CODE16:nop_stub_IDC
                db 'nop$     '
                db 8 dup (0)
                dw 0000000000011011b
                dw 0000000000000000b
DATA16 ends

CODE16 segment
        assume cs:CODE16, ds:DATA16

        extrn code16_end : byte
	extrn nop_devhlp_init16 : far
;SYSC	extrn nop_syscall_init : far

	extrn	Dos32FlatCS : abs
	extrn	Dos32FlatDS : abs
;SEC	extrn	_NOP_CALLGATE16ASM : far

        public	nop_stub_strategy
        public	nop_stub_IDC

nop_stub_strategy proc far
        movzx	eax, byte ptr es:[bx+2]
        cmp	eax, 0
        jz	short err1
	cmp	eax, 01bh
	jnz	f1
	call	nop_devhlp_init16
	call	far ptr FLAT:nop_init32
f1:
        push	es		; seg reqpkt
        push	bx		; off reqpkt
        push	eax		; command

        mov	word ptr es:[bx+3], 0		; updates the request status
        call	far ptr FLAT:NOP_STRATEGY	; 32 bits strategy entry point
        mov	word ptr es:[bx+3], ax		; updates the request status
        retf

err1:
        mov	dword ptr es:[bx+14], 0
        mov	word ptr es:[bx+3], STDON + STERR + ERROR_I24_BAD_COMMAND
        retf
nop_stub_strategy endp

nop_stub_IDC proc far
        call	far ptr FLAT:NOP_IDC
        retf
nop_stub_IDC endp
CODE16 ends

CODE32 segment
ASSUME CS:FLAT, DS:FLAT, ES:FLAT

        public begin_code32
	public nop_int3

        extrn  NOP_STRATEGY : far
        extrn  NOP_IDC      : far

begin_code32:
	nop

nop_int3 proc near
	int 	3
	ret
nop_int3 endp

nop_init32	proc far
	push	ds
	push	eax
	mov	eax, Dos32FlatDS
	mov	ds, ax
	ASSUME	ds:FLAT
;SEC	mov	ax, offset _NOP_CALLGATE16ASM
;SEC	shl	eax, 16
;SEC	mov	ax, CODE16
;SEC	mov	[SecImp+44h], eax
	pop	eax
	pop	ds
	retf
nop_init32	endp

CODE32	ends

BSS32 segment
        public  begin_data32

        begin_data32 dd (?)
BSS32	ends
	end

